const { existsSync, rmSync } = require('fs')
const { spawn } = require("child_process");
const { platform } = require("os");;
const { Logger } = require('../utils/Logger')
const { getLintConfigDirectory } = require("./getFileUtils");
const { executeSynchronizedCommands }  = require('../utils/executeSyncCommands')

function unzipFolder() {
  const configZipPath = getLintConfigDirectory();
  const command = [`-xvf`, `${configZipPath}`];
  const command_prefix = "tar";
  const childProcess = spawn(command_prefix, command, {
    shell: true
  })
  childProcess.on('exit',() => {
    removeFolder(configZipPath)
  })
  return;
}


function removeFolder(folderPath){
  try{
    let isCommonConfigFolderPresent = existsSync(folderPath)
    if(isCommonConfigFolderPresent){
      executeSynchronizedCommands(rmSync,[folderPath,{recursive:true, force:true}],'common linter configuration folder removed successfully','Unable to remove the common linter configuration folder',false,false)
    }
    else{
      Logger.log(Logger.SUCCESS_TYPE,'Configuration folder not present')
    }
  }
  catch(error){
    Logger.log(Logger.FAILURE_TYPE,error)
    Logger.log(Logger.FAILURE_TYPE,'Unable to check if common linter configuratio folder is present')
  }
}


function isWindows(){
    return _os = platform().toLowerCase() === "win32";
}



module.exports = {
  isWindows,
  unzipFolder,
  removeFolder
};
