#!/usr/bin/env node

const { setupHusky } = require("../pre-commit/huskySetup/setupHusky");
const { initialSetup } = require("../pre-commit/initialSetup");
const { handleIfFalse_ExceptionCase } = require("../utils/getScripts");
const { installEslintExtension } = require("../utils/installEslintExtension");
const { installPlugins } = require("../utils/PluginsInstallationUtils/installPlugins")
const [, , action, ...options ] = process.argv;


async function run(){
  switch (action) {
    case "setup": {
      await handleIfFalse_ExceptionCase('Some issue occurred in setting up husky.',setupHusky,null)
      break;
    }
  
    case "init": {
      initialSetup()
      break;
    }
  
    case "setupPlugins" : {
      await handleIfFalse_ExceptionCase('Some issue occurred in installing plugins',installPlugins,null);
      break;
    }

    case "setupExtension" : {
      await handleIfFalse_ExceptionCase('Kindly install eslint extension for Vscode manually.',installEslintExtension,null);
      break;
    }
  
    default: {
      break;
    }
  }
}


run()