/* eslint-disable no-console */
const os = require('os')
const fs = require('fs')
const { Logger } = require('../utils/Logger');

function grantExecutionPermission(filesToWhichExecutionPermissionToBeGiven){
   let ostype = os.type();
   if(ostype === 'Darwin' || ostype === 'Linux'){
      let filesThatWereGivenExecutionPermission = filesToWhichExecutionPermissionToBeGiven.filter(file => {
         try{
            fs.chmodSync(file,'755')
            Logger.log(Logger.SUCCESS_TYPE,`execution permission given to ${file}`)
            return true
         }
         catch(error){
            Logger.log(Logger.FAILURE_TYPE,error)
            Logger.log(Logger.FAILURE_TYPE,`Unable to give execution permission to ${file}`)
            return false
         }
      })
      return filesThatWereGivenExecutionPermission.length === filesToWhichExecutionPermissionToBeGiven.length ?  true : false
   }
   else{
      return true
   }
}

module.exports = grantExecutionPermission
