const { existsSync,writeFileSync } = require("fs");
const path = require("path");
const { Logger } = require("../utils/Logger");
function initialSetup() {
  const package_json_path = path.resolve(process.cwd(),"package.json");
  updatePackageJSON(package_json_path,'scripts',getSetupScript());
}

function getSetupScript() {
  return {
    installRulePlugins: "ZDPrecommit setupPlugins",
    setupVSCodeExtension: "ZDPrecommit setupExtension"
  };
}

function updatePackageJSON(packageJsonPath,partToUpdate,updateObject) {
  if (existsSync(packageJsonPath)) {
    const packageContents = require(packageJsonPath);
    const existingJSON = packageContents[partToUpdate] || {}
    const modifiedScripts = { ...existingJSON, ...updateObject };
    const modifiedConfigJSON = { ...packageContents, scripts: modifiedScripts };
    writeFileSync(packageJsonPath, JSON.stringify(modifiedConfigJSON, null, 2));
  } else {
    Logger.log(Logger.FAILURE_TYPE,"Unable to find package json. Run init command in the root path of the project.");
  }
}

module.exports = {
    initialSetup
}
