const { execSync } = require('child_process')
const { checkIfPluginsAreInstalled } = require('./checkIfPluginsAreInstalled')
const { executeSynchronizedCommands } = require('../executeSyncCommands')
const { Logger } = require('../Logger')

function installPlugins(){
    let uninstalledPlugins = checkIfPluginsAreInstalled()
    let pluginsToBeInstalled = uninstalledPlugins.uninstalledPlugins
    if(pluginsToBeInstalled.length > 0){
        let installCommand = `npm install --save-dev ${pluginsToBeInstalled.join(' ')}`
        Logger.log(Logger.INFO_TYPE,'Installing plugins ....')
        Logger.log(Logger.INFO_TYPE,`Install command being executed: ${installCommand}`)

        let arePluginsInstalledSuccessfully = executeSynchronizedCommands(execSync,[installCommand,{stdio:'inherit'}],'','Some issue occured while installing plugins',false,true)
        if(arePluginsInstalledSuccessfully){
            Logger.log(Logger.SUCCESS_TYPE,'Plugins installation successful')
            return true
        }
        else {
            Logger.log(Logger.FAILURE_TYPE,"Unable to install plugins.Kindly retry the command")
            return false
        }
    }
    else{
        Logger.log(Logger.INFO_TYPE,'Plugins are already installed')
        return true
    }
}

// function appendInstalledPluginsToPackageJson(pluginsToBeAppendedInPackageJson){
//     let packageJsonFilePath = `${nodeModulesPathOfProject}/package.json`
//     let packageJsonContent = require(packageJsonFilePath)
//     let devDependencies = packageJsonContent.devDependencies
//     let pluginsToBeAddedInDevDependencies = {}

//     executeSynchronizedCommands(process.chdir,[nodeModulesPathOfProject],'','Unable to navigate to node_modules path when trying to revert changes in package.json',false,false)
    
//     let gitDiffOutput = executeSynchronizedCommands(execSync,['git diff --name-only'],'','Unable to execute git diff command while checking if package.json is changed',true,false).toString().trim()
//     let isPackageJsonChanged = gitDiffOutput.includes('package.json') ? true : false

//     if(isPackageJsonChanged){
//         let packageJsonChangesRevertCommand = `git checkout "${packageJsonFilePath}"`
//         isPackageJsonChangesRevertedSuccessfully = executeSynchronizedCommands(execSync,[packageJsonChangesRevertCommand,{stdio:'inherit'}],'Changes in package.json reverted successfully','Unable to revert the changes in package.json file',false,true)
        
//         if(isPackageJsonChangesRevertedSuccessfully){
//             pluginsToBeAppendedInPackageJson.map(uninstalledPlugin => {
//                 if(uninstalledPlugin.startsWith('@')){
//                     let indexOfAtCharacter = uninstalledPlugin.indexOf('@')
//                     let indexOfSecondOccurenceOfAtCharacter = uninstalledPlugin.indexOf('@',indexOfAtCharacter + 1)
//                     let unInstalledPluginName = uninstalledPlugin.slice(0,indexOfSecondOccurenceOfAtCharacter)
//                     let unInstalledPluginVersion = uninstalledPlugin.slice(indexOfSecondOccurenceOfAtCharacter + 1)
//                     pluginsToBeAddedInDevDependencies[unInstalledPluginName] = unInstalledPluginVersion
//                 }
//                 else{
//                     pluginsToBeAddedInDevDependencies[uninstalledPlugin.split('@')[0]] = uninstalledPlugin.split('@')[1]
//                 }
//                 })
//                 let updatedPluginsIndevDependencies = {
//                     ...devDependencies,
//                     ...pluginsToBeAddedInDevDependencies
//                 }
//                 packageJsonContent.devDependencies = updatedPluginsIndevDependencies
                
//                 let modifiedPackageJson = {
//                     ...packageJsonContent,
//                 }
//                 let isPluginsAddedInPackageJson = executeSynchronizedCommands(writeFileSync,[packageJsonFilePath,JSON.stringify(modifiedPackageJson,null,2)],'Newly installed plugins successfully added to package.json','Unable to append installed plugins to package.json',false,true)
//                 return isPluginsAddedInPackageJson 
//         }
//         else{
//             return true
//         }
//     }
// }

module.exports = {
    installPlugins
}