const {existsSync, appendFileSync} = require('fs')
const { getRootDirectory } = require("./navigateToRootDirectory");
const { getRepoName } = require("../pre-commit/gitSetup/gitUtils/gitActions");
const { getLibraryInstalledLocation } = require('./getLibraryInstalledLocation')
const { repoURL } = require("../preCommitRequestUtils.json");
const { handleExceptionCase } = require("./getScripts");
const path = require('path')

function getClonedDirPath(){
  return getLibraryInstalledLocation()
}

function getDeleteDirPath(){
  return path.resolve(__dirname,'..','configuration')
}

function deleteFile(filePath) {
  if (existsSync(filePath)) {
    try {
      fs.unlinkSync(filePath);
    } catch (err) {
      throw new Error(`Error while deleting the test data file: ${filePath}`)
    }
  }
}


function updateGitIgnore(appendFilePath){
  const addInGitIgnore =  path.resolve(getRootDirectory(),'.gitignore')
  appendFileSync(addInGitIgnore,appendFilePath.toString())
}

function getLintConfigurationUtil(){
const repoName = getRepoName(); 
let commonConfigPath = path.join( __dirname,'..','configuration','services','common','index.js')
let serverConfigPath = path.join( __dirname,'..','configuration','services',repoName,'index.js')
const configurationPath = repoName ?  serverConfigPath : commonConfigPath 
const exceptionHandleObject = {
  rulesConfig: [{}, {}],
  plugins: [],
  extendPlugins: []
};

return handleExceptionCase(
  exceptionHandleObject,
  `Kindly Ensure that Configuration is setup in Configuration repo \n ${repoURL}`,
  require,
  configurationPath
);
}

module.exports = {
  deleteFile,
  getClonedDirPath,
  getDeleteDirPath,
  updateGitIgnore,
  getLintConfigurationUtil
};
