/* eslint-disable no-console */
const fs = require('fs')
const { Logger } = require('./Logger')
const { getRootDirectory } = require('./navigateToRootDirectory')
const NODE_MODULES_NOT_FOUND = 'node_modules folder not found'

function getNodeModulesPath(){
    let rootDir = ''
    let isNodeModulesPath = false
    let isPackageJsonPath = false
    let isPathWherePluginsAreInstalled = false
    let nodeModulesPathOfProject = ''
    let firstLevelDirectoriesFromRoot = []
    let secondLevelDirectoriesFromRoot = []
    let thirdLevelDirectoriesFromRoot = []

    try{
        rootDir = getRootDirectory()
    }
    catch(error){
        Logger.log(Logger.FAILURE_TYPE,error)
        Logger.log(Logger.FAILURE_TYPE,'Initialize the repository using \"git init\" command')
        return process.cwd()
    }
    let directoryToBeChecked = rootDir

    firstLevelDirectoriesFromRoot = fs.readdirSync(`${rootDir}`)
    isNodeModulesPath = firstLevelDirectoriesFromRoot.includes('node_modules')
    isPackageJsonPath = firstLevelDirectoriesFromRoot.includes('package.json')

    isPathWherePluginsAreInstalled = isNodeModulesPath && isPackageJsonPath

    if(isPathWherePluginsAreInstalled){
        nodeModulesPathOfProject = rootDir
    }
    else{
        firstLevelDirectoriesFromRoot.filter(firstLevelDir =>{
                if(! firstLevelDir.includes('.')){
                    directoryToBeChecked = `${rootDir}`
                    let stats = fs.statSync(`${directoryToBeChecked}/${firstLevelDir}`)
                    if(stats.isDirectory()){
                        secondLevelDirectoriesFromRoot = fs.readdirSync(`${directoryToBeChecked}/${firstLevelDir}`)
                        isNodeModulesPath = secondLevelDirectoriesFromRoot.includes('node_modules')
                        isPackageJsonPath = secondLevelDirectoriesFromRoot.includes('package.json')
                        isPathWherePluginsAreInstalled = isNodeModulesPath && isPackageJsonPath
                    }
                    else{
                        return false
                    }

                    if(isPathWherePluginsAreInstalled){
                        nodeModulesPathOfProject = `${directoryToBeChecked}/${firstLevelDir}`
                        return true
                    }
                    else{
                        secondLevelDirectoriesFromRoot.filter(secondLevelDir => {
                            if(! secondLevelDir.includes('.')){
                                directoryToBeChecked = `${directoryToBeChecked}`
                                let stats = fs.statSync(`${directoryToBeChecked}/${firstLevelDir}/${secondLevelDir}`)
                                if(stats.isDirectory()){
                                    thirdLevelDirectoriesFromRoot = fs.readdirSync(`${directoryToBeChecked}/${firstLevelDir}/${secondLevelDir}`)
                                    isNodeModulesPath = thirdLevelDirectoriesFromRoot.includes('node_modules')
                                    isPackageJsonPath = thirdLevelDirectoriesFromRoot.includes('package.json')
                                    isPathWherePluginsAreInstalled = isNodeModulesPath && isPackageJsonPath
                                }
                                else{
                                    return true
                                }
                            }
                            if(isPathWherePluginsAreInstalled){
                                nodeModulesPathOfProject = `${directoryToBeChecked}/${firstLevelDir}/${secondLevelDir}`
                                return true
                            }
                        })
                    }
                }
        })
    }
    if(nodeModulesPathOfProject !== ''){
        return nodeModulesPathOfProject
    }
    else{
        Logger.log(Logger.INFO_TYPE,NODE_MODULES_NOT_FOUND)
        return process.cwd()
    }
}

module.exports=getNodeModulesPath

