const path = require("path");
const getNodeModulesPath = require("./getNodeModulesPath");
const { Logger } = require("./Logger");

function getShellScript() {
  return path.resolve(
    getNodeModulesPath(),
    "node_modules",
    "@zohodesk",
    "precommitlibrary",
    "bin",
    "execute.js",
  );
}

async function handleIfFalse_ExceptionCase(
  consoleMessage,
  _callback,
  ...params
) {
  if (!(await _callback(...params))) {
    throw new Error(consoleMessage);
  }
}

function handleExceptionCase(
  handleObject,
  consoleMessage,
  _callback,
  ...params
) {
  try {
    return _callback(...params);
  } catch (err) {
    Logger.log(Logger.FAILURE_TYPE, err);
    Logger.log(Logger.FAILURE_TYPE, consoleMessage);
    return handleObject;
  }
}

function isrequireThere(filePath) {
  try {
    require(filePath);
    return true;
  } catch (err) {
    return false;
  }
}

module.exports = {
  getShellScript,
  handleIfFalse_ExceptionCase,
  handleExceptionCase,
  isrequireThere
};
