const { execSync } = require('child_process')
const { executeSynchronizedCommands } = require('./executeSyncCommands')
const { Logger } = require('./Logger')

function installEslintExtension(){
    let eslintExtensionCode = 'dbaeumer.vscode-eslint'
    Logger.log(Logger.INFO_TYPE,'Installing eslint extension for Vscode....')
    let isEslintExtensionInstalledSuccessfully = executeSynchronizedCommands(
        execSync,
        [`code --install-extension ${eslintExtensionCode}`],
        'Eslint extension for vscode installed successfully! If eslint errors not being reported in editor, kindly restart Vscode',
        'Unable to install eslint extension for vscode',
        false,
        true
    )
    return isEslintExtensionInstalledSuccessfully
}

module.exports = {
    installEslintExtension
}