/* eslint-disable no-console */

const { spawnSync } = require("child_process");
const { Logger } = require("./Logger");

function getRootDirectory() {
  let rootDir = spawnSync('git',["rev-parse","--show-toplevel"],{shell:true,encoding:'utf-8'})
  if(!(rootDir.status == 0)){
    return process.cwd()
  }
  return rootDir.toString()
  .trim();
}

function navigateToRootDirectory(rootDir) {
  Logger.log(Logger.INFO_TYPE,`rootDir:${rootDir}`);

  try {
    process.chdir(rootDir);
    Logger.log(Logger.INFO_TYPE,"Successfully navigated to root directory");
    return true;
  } catch (error) {
    Logger.log(Logger.FAILURE_TYPE,"Couldn't navigate to root directory", error);
    return false;
  }
}

module.exports = { navigateToRootDirectory,getRootDirectory };
